package com.timothyveletta;

/**
 * @author Timothy Veletta
 *
 * @param <T> 
 */
public abstract class State {
	protected FuzzyBot object;
	protected double activationLevel;
	
	public State(FuzzyBot obj) {
		object = obj;
		activationLevel = 0.0;
	}
	
	public abstract void Init();

	public void Update() { CalculateActivation(); }
	
	public abstract void CalculateActivation();
}
