package dsekercioglu.mega.wfGun.gun;

import dsekercioglu.mega.megaCore.KNNPredictor;
import static dsekercioglu.mega.megaCore.KNNPredictor.DistanceFunction.EUCLIDEAN;
import static dsekercioglu.mega.megaCore.KNNPredictor.DistanceFunction.MANHATTAN;
import static dsekercioglu.mega.megaCore.KNNPredictor.DistanceFunction.SQR_EUCLIDEAN;
import dsekercioglu.mega.wfGun.GunUtils;

public class AntiAdaptiveGun extends AbstractPredictor {

    private final KNNPredictor PREDICTOR;
    public final int BINS;
    public final int K = 20;
    public final int SIZE_DIVIDER = 5;

    public AntiAdaptiveGun(int bins) {
        BINS = bins;
        PREDICTOR = new KNNPredictor();
        PREDICTOR.setup(new double[]{7, 4, 5, 5, 4, 3, 5, 5, 0.1}, K, BINS, SQR_EUCLIDEAN, PREDICTOR.divisionK(K, SIZE_DIVIDER));
    }

    public double[] predict(double[] data) {
        return GunUtils.normalizeBinValuesExp(PREDICTOR.predictBins(data));
    }

    public void wavePassed(double[] data, int bin, boolean real) {
        PREDICTOR.addData(data, bin, real ? 1 : 0.1);
    }

    public String getName() {
        return "Anti-Adaptive Gun";
    }
}
