package dsekercioglu.mega.wfMove.move.formulas;

import dsekercioglu.mega.wfMove.Lightning;

public class SimpleFormula extends Formula {

    private final double[] WEIGHTS = {1, 1, 1, 0};

    @Override
    public double[] getDataPoint(Lightning.BattleInfo data) {
        double[] dataPoint = {Math.abs(data.lateralVelocity) / 8,
            (data.advancingVelocity + 8) / 16,
            (data.distance / 1000),
            data.enemyHit};
        return dataPoint;
    }

    @Override
    public double[] getWeights() {
        return WEIGHTS;
    }

    @Override
    public Formula setDecay(double d) {
        WEIGHTS[WEIGHTS.length - 1] = d;
        return this;
    }

}
